using System;
using System.Data;
using System.Collections.Generic;
using RMYY_CallCenter_Api.Utility;

namespace RMYY_CallCenter_Api.Bll
{
    /// <summary>
    /// T_Sys_Menu
    /// </summary>
    public partial class T_Sys_Menu
    {
        private readonly Dal.T_Sys_Menu dal = new Dal.T_Sys_Menu();
        public T_Sys_Menu()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(string F_MenuCode)
        {
            return dal.Exists(F_MenuCode);
        }

        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(Model.T_Sys_Menu model)
        {
            CacheHelper.Remove("AuthActions");
            return dal.Add(model);
        }

        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.T_Sys_Menu model)
        {
            CacheHelper.RemoveContain("RoleMenus_");
            CacheHelper.RemoveContain("RoleActions_");
            CacheHelper.Remove("AuthActions");
            return dal.Update(model);
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_MenuId)
        {
            CacheHelper.RemoveContain("RoleMenus_");
            CacheHelper.RemoveContain("RoleActions_");
            CacheHelper.Remove("AuthActions");
            return dal.Delete(F_MenuId);
        }
        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool DeleteList(string F_MenuIdlist)
        {
            CacheHelper.RemoveContain("RoleMenus_");
            CacheHelper.RemoveContain("RoleActions_");
            CacheHelper.Remove("AuthActions");
            return dal.DeleteList(F_MenuIdlist);
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Sys_Menu GetModel(int F_MenuId)
        {
            return dal.GetModel(F_MenuId);
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Sys_Menu GetModel(string F_MenuCode)
        {

            return dal.GetModel(F_MenuCode);
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            return dal.GetList(strWhere);
        }
        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            return dal.GetList(Top, strWhere, filedOrder);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<Model.T_Sys_Menu> GetModelList(string strWhere)
        {
            DataSet ds = dal.GetList(strWhere);
            return DataTableToList(ds.Tables[0]);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<Model.T_Sys_Menu> DataTableToList(DataTable dt)
        {
            List<Model.T_Sys_Menu> modelList = new List<Model.T_Sys_Menu>();
            int rowsCount = dt.Rows.Count;
            if (rowsCount > 0)
            {
                Model.T_Sys_Menu model;
                for (int n = 0; n < rowsCount; n++)
                {
                    model = dal.DataRowToModel(dt.Rows[n]);
                    if (model != null)
                    {
                        modelList.Add(model);
                    }
                }
            }
            return modelList;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetAllList()
        {
            return GetList("");
        }

        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            return dal.GetRecordCount(strWhere);
        }

        #endregion  BasicMethod
    }
}

